
'$DYNAMIC
DEFINT A-Z
DECLARE SUB credits ()
DECLARE SUB Pixelate (divisor%)
DECLARE FUNCTION MoveObj% (objnum%, facex%, facey%)
DECLARE SUB SwapTo (describe$, x%, y%, id%)
DECLARE SUB DumpStuff (describe$, id%)
DECLARE SUB LoadStuff (describe$, x%, y%, idnum%)
DECLARE FUNCTION CheckKey% (num%)
DECLARE SUB SetKey (num%)
DECLARE SUB WipeKey ()
DECLARE SUB execbattle ()
DECLARE SUB DrawPow (x1%, y1%, x2%, y2%)
DECLARE SUB init ()
DECLARE SUB AddWindow (x1%, y1%, x2%, y2%, messages%)
DECLARE SUB ExecScript (objnum%)
DECLARE SUB ProcessCommands (obj%, fromobj%, filenum%, message%)
DECLARE SUB ProcessLine (filenum%, commandnum%, search$)
DECLARE SUB AddObject (x%, y%, idnum%, spr%, sfile$)
DECLARE SUB DoAi (objnum%)
DECLARE SUB SendMessage (objnum%, fromobj%, message%)
DECLARE SUB RenderMap ()
DECLARE SUB FocusCamera ()
DECLARE SUB CloseWindow ()
DECLARE SUB DrawWindow ()
DECLARE SUB ExecObjects ()
DECLARE SUB fontprint (x%, y%, text$)
DECLARE SUB DisplayMap ()
DECLARE SUB SetScreen (palfile$, bufseg%)
DECLARE SUB put13h (BYVAL OBJSegm%, BYVAL OBJOffs%, BYVAL x%, BYVAL y%, BYVAL col%)
DECLARE SUB setsegments13h (BYVAL SSegm%, BYVAL DSegm%)
DECLARE SUB initkbd ALIAS "installisr" (BYVAL arrayseg%, BYVAL arrayofs%)
DECLARE SUB deinitkbd ALIAS "removeisr" ()
DECLARE SUB copy13h ()

CONST debug = 0

CONST halt = -1
CONST hit = 1
CONST msg = 2
CONST zap = 3
CONST move = 4
CONST delay = 5
CONST lzap = 6
CONST sprchange = 7

IF debug < 0 THEN ON ERROR GOTO boink

TYPE camera
x AS INTEGER
y AS INTEGER
END TYPE

TYPE object
steps AS LONG
extrafun AS LONG
sfile AS STRING * 8
idnum AS INTEGER
spr AS INTEGER
oname AS STRING * 16
x AS INTEGER
y AS INTEGER
queuex AS INTEGER
queuey AS INTEGER
facex AS INTEGER
facey AS INTEGER
frames AS INTEGER
delay AS LONG
currline AS INTEGER
script(50, 3) AS INTEGER
zaparray(15) AS INTEGER
storemessage AS INTEGER
END TYPE

TYPE msgline
lines(20) AS STRING * 40
END TYPE


TYPE windowt
x1 AS INTEGER
y1 AS INTEGER
x2 AS INTEGER
y2 AS INTEGER
currx AS INTEGER
curry AS INTEGER
currx2 AS INTEGER
curry2 AS INTEGER
openclosingsign AS INTEGER
messages AS INTEGER
Top AS INTEGER
Bottom AS INTEGER
Linedisp AS INTEGER
charx AS INTEGER
chary AS INTEGER
font(33, 127) AS INTEGER
windowtile(33, 8) AS INTEGER
buffer(20, 37) AS INTEGER
windowstr(20) AS STRING * 40
DelayFrames AS LONG
WindowUp AS INTEGER
WindowDone AS INTEGER
WindowOn AS INTEGER

END TYPE

DIM SHARED dbuffer(32766) AS INTEGER

DIM SHARED mapdisplayframes&


DIM SHARED errdata
DIM SHARED omap(89, 89) AS INTEGER
DIM SHARED CoinCounter
DIM SHARED coins
DIM SHARED map(89, 89) AS INTEGER
DIM SHARED monster(513, 0) AS INTEGER
DIM SHARED BattleOver
DIM SHARED keyboard(255)
DIM SHARED coin(33)

DIM SHARED Battle(513, 3, 6)
DIM SHARED char(129, 15, 4)
DIM SHARED nmobj(129, 6)
DIM SHARED tiles(129, 50)
DIM SHARED mapname$(1 TO 5)
DIM SHARED mapdescribe$
DIM SHARED mapid
DIM SHARED flags(1024)

DIM SHARED frames&
DIM SHARED scene
DIM SHARED message(50) AS msgline
DIM SHARED currmessage AS INTEGER
DIM SHARED objects(16) AS object
DIM SHARED maxobjects
DIM SHARED facetable(-1 TO 1, -1 TO 1)
DIM SHARED BlueWindow AS windowt
DIM SHARED camera AS camera
maxobjects = UBOUND(objects, 1)
mapname$(1) = "Cave of Mystery"
mapname$(2) = "Feeb Town"

c$ = COMMAND$
IF c$ <> "-LOAD" THEN WipeKey
init
LoadStuff "cave", 1230, 64, 1
DumpStuff mapdescribe$, mapid
scene = 2
DO

IF BlueWindow.WindowOn = 0 THEN ExecObjects
FocusCamera
DisplayMap
IF BlueWindow.WindowUp = 1 AND BlueWindow.WindowDone = 1 AND keyboard(57) = 1 THEN CloseWindow
IF BlueWindow.WindowOn = 1 THEN DrawWindow
IF BlueWindow.WindowUp = -1 THEN BlueWindow.WindowOn = 0: BlueWindow.WindowUp = 0
IF keyboard(41) = 0 THEN WAIT &H3DA, 8
IF mapdisplayframes& > frames& AND BlueWindow.WindowOn = 0 THEN
b$ = mapname$(mapid)
a = (40 - LEN(b$)) \ 2
DrawPow 40, 0, 279, 16
fontprint 8 * a, 8, b$
END IF
IF CoinCounter = 1 THEN
IF coins = 8 THEN flags(0) = 1
IF coins > 8 THEN coins = 8
put13h VARSEG(coin(0)), VARPTR(coin(0)), 296, 192, 0
fontprint 304, 192, "x" + LTRIM$(RTRIM$(STR$(coins)))
END IF
IF flags(1024) = 1 THEN credits: EXIT DO
copy13h
frames& = frames& + 1
LOOP UNTIL keyboard(1)
IF debug <> 2 THEN deinitkbd
SYSTEM

boink:

IF debug <> 2 THEN deinitkbd
SCREEN 0: WIDTH 80, 25
PRINT "oops, an error"
PRINT errdata
SYSTEM

REM $STATIC
SUB AddObject (x, y, idnum, spr, sfile$)
k = -1
FOR i = 0 TO maxobjects
IF objects(i).idnum = -1 THEN k = i: EXIT FOR
NEXT
IF k = -1 THEN EXIT SUB
objects(k).sfile = sfile$
objects(k).idnum = idnum
objects(k).spr = spr
objects(k).queuex = 0
objects(k).queuey = 0
objects(k).x = (x \ 16) * 16
objects(k).y = (y \ 16) * 16
omap(objects(k).x \ 16, objects(k).y \ 16) = k

END SUB

SUB AddWindow (x1, y1, x2, y2, messages)
FOR i = 0 TO 20
FOR j = 0 TO 37
BlueWindow.buffer(i, j) = 0
NEXT j, i
BlueWindow.messages = messages
BlueWindow.x1 = (x1 \ 8) * 8
BlueWindow.x2 = (x2 \ 8) * 8
BlueWindow.y1 = (y1 \ 8) * 8
BlueWindow.y2 = (y2 \ 8) * 8
BlueWindow.currx = (BlueWindow.x2 - BlueWindow.x1) \ 2 - 8
BlueWindow.currx2 = (BlueWindow.x2 - BlueWindow.x1) \ 2 + 8
BlueWindow.curry = (BlueWindow.y2 - BlueWindow.y1) \ 2 - 8
BlueWindow.curry2 = (BlueWindow.y2 - BlueWindow.y1) \ 2 + 8
BlueWindow.openclosingsign = 1
BlueWindow.Linedisp = 6
BlueWindow.Top = 0
BlueWindow.Bottom = BlueWindow.Top + BlueWindow.Linedisp
IF BlueWindow.Bottom > BlueWindow.messages THEN BlueWindow.Bottom = BlueWindow.messages

BlueWindow.charx = 0
BlueWindow.chary = 0

BlueWindow.WindowOn = 1
BlueWindow.WindowUp = 0
BlueWindow.WindowDone = 0

END SUB

FUNCTION CheckKey% (num)
DIM tkey(4)
OPEN "auto\maptog.dat" FOR INPUT AS #1
INPUT #1, tkey(0)
INPUT #1, tkey(1)
INPUT #1, tkey(2)
INPUT #1, tkey(3)
INPUT #1, tkey(4)
CLOSE #1
CheckKey% = tkey(num - 1)
END FUNCTION

SUB CloseWindow
BlueWindow.WindowUp = 0
BlueWindow.openclosingsign = -1
BlueWindow.x1 = (BlueWindow.currx2 - BlueWindow.currx) \ 2 - 8
BlueWindow.x2 = (BlueWindow.currx2 - BlueWindow.currx) \ 2 + 8
BlueWindow.y1 = (BlueWindow.curry2 - BlueWindow.curry) \ 2 - 8
BlueWindow.y2 = (BlueWindow.curry2 - BlueWindow.curry) \ 2 + 8
END SUB

SUB credits

y = 0
DIM credit$(30)
credit$(0) = "DRUNKATOR"
credit$(1) = ""
credit$(2) = ""
credit$(3) = "PROGRAMMED BY:"
credit$(4) = "Ryan Broomfield"
credit$(5) = ""
credit$(6) = "DESIGNED BY:"
credit$(7) = "Ryan Broomfield"
credit$(8) = ""
credit$(9) = "SCRIPT BY:"
credit$(10) = "Ryan Broomfield"
credit$(11) = ""
credit$(12) = "SPECIAL THANKS TO:"
credit$(13) = "#coders, #quickbasic, #zsnes"
credit$(14) = "#zsnesboard, #shippy, #turkishguy"
credit$(15) = "Yenen, Neoblaze, kode54, Densetsufreak"
credit$(16) = "***FILL IN WITH REST OF GR33tZ***"
credit$(17) = ""
credit$(18) = "THE END"

FOR i = 19 TO 30
credit$(i) = ""
NEXT

DIM drawn(30) AS INTEGER

DIM blah(1281)
LINE (0, 0)-(319, 7), 0, BF
GET (0, 0)-(319, 7), blah
DO
REDIM dbuffer(32766) AS INTEGER
start = y \ 8
boink = -(y AND 7)
FOR i = 0 TO 23
lines = (start + i) \ 4
IF lines > 30 THEN EXIT DO
IF lines > 0 AND lines < 30 THEN
IF drawn(lines) = 0 THEN fontprint 0, boink + (i * 8), credit$(lines): drawn(lines) = 1
END IF
NEXT
FOR i = 0 TO 30
drawn(i) = 0
NEXT
IF (frames& AND 7) = 3 THEN y = y + 1
put13h VARSEG(blah(0)), VARPTR(blah(0)), 0, 0, -1
put13h VARSEG(blah(0)), VARPTR(blah(0)), 0, 312, -1
WAIT &H3DA, 8
copy13h
frames& = frames& + 1
LOOP UNTIL keyboard(1)

END SUB

SUB DisplayMap
DIM found(maxobjects)
startx = -(camera.x AND 15)
starty = -(camera.y AND 15)
StartMapX = camera.x \ 16
StartMapY = camera.y \ 16
locationx = startx
locationy = starty
Endx = 19 - SGN(startx)
Endy = 13 - SGN(starty)
FOR showy = 0 TO Endy
FOR showx = 0 TO Endx
til = map(StartMapX + showx, StartMapY + showy)
til2 = omap(StartMapX + showx, StartMapY + showy)
IF til <> -1 THEN til = til AND 255: put13h VARSEG(tiles(0, til)), VARPTR(tiles(0, til)), locationx, locationy, -1 ELSE put13h VARSEG(tiles(0, 10)), VARPTR(tiles(0, 10)), locationx, locationy, -1
IF til2 <> -1 THEN found(til2) = 1
locationx = locationx + 16
NEXT
locationy = locationy + 16
locationx = startx
NEXT

        FOR i = 0 TO maxobjects
        IF found(i) = 1 THEN
        til2 = i
        boink = objects(til2).x - camera.x
        boink2 = objects(til2).y - camera.y
        SELECT CASE objects(til2).idnum
        CASE 0, 1, 2
                        IF objects(til2).queuex = 0 AND objects(til2).queuey = 0 THEN
                        frame = objects(til2).frames
                        ELSE
                        frame = facetable(SGN(objects(til2).queuex), SGN(objects(til2).queuey))
                        IF objects(til2).queuex <> 0 THEN frame = frame + ABS(objects(til2).queuex) \ 4 ELSE frame = frame + ABS(objects(til2).queuey) \ 4
                        objects(til2).frames = frame
                        END IF
        put13h VARSEG(char(0, frame, objects(til2).spr)), VARPTR(char(0, frame, objects(til2).spr)), boink, boink2, 3

        CASE 3
        put13h VARSEG(nmobj(0, objects(til2).spr)), VARPTR(nmobj(0, objects(til2).spr)), boink, boink2, 3

        END SELECT

        END IF
        NEXT




END SUB

SUB DoAi (objnum)
SELECT CASE objects(objnum).idnum
CASE -1
CASE 0
objects(objnum).facex = keyboard(77) - keyboard(75)
objects(objnum).facey = keyboard(80) - keyboard(72)
IF objects(objnum).facey <> 0 THEN objects(objnum).facex = 0
a% = MoveObj%(objnum, objects(objnum).facex, objects(objnum).facey)
'IF objects(objnum).steps > objects(objnum).extrafun THEN execbattle: objects(objnum).extrafun = objects(objnum).steps + 100 + (900 * RND)

CASE ELSE
ExecScript objnum
END SELECT

END SUB

SUB DrawPow (x1, y1, x2, y2)
boink = (x1 \ 8) * 8
boink2 = (y1 \ 8) * 8
boinkx2 = (x2 \ 8) * 8
boinky2 = (y2 \ 8) * 8

xdraw = (boinkx2 \ 8) - (boink \ 8)
ydraw = (boinky2 \ 8) - (boink2 \ 8)
put13h VARSEG(BlueWindow.windowtile(0, 0)), VARPTR(BlueWindow.windowtile(0, 0)), boink, boink2, 0
put13h VARSEG(BlueWindow.windowtile(0, 2)), VARPTR(BlueWindow.windowtile(0, 2)), boink, boinky2, 0
put13h VARSEG(BlueWindow.windowtile(0, 1)), VARPTR(BlueWindow.windowtile(0, 1)), boinkx2, boink2, 0
put13h VARSEG(BlueWindow.windowtile(0, 3)), VARPTR(BlueWindow.windowtile(0, 3)), boinkx2, boinky2, 0
FOR drawx = 1 TO xdraw - 1
put13h VARSEG(BlueWindow.windowtile(0, 7)), VARPTR(BlueWindow.windowtile(0, 7)), drawx * 8 + boink, boink2, 0
put13h VARSEG(BlueWindow.windowtile(0, 6)), VARPTR(BlueWindow.windowtile(0, 6)), drawx * 8 + boink, boinky2, 0
NEXT
FOR drawy = 1 TO ydraw - 1
put13h VARSEG(BlueWindow.windowtile(0, 5)), VARPTR(BlueWindow.windowtile(0, 5)), boink, drawy * 8 + boink2, 0
put13h VARSEG(BlueWindow.windowtile(0, 4)), VARPTR(BlueWindow.windowtile(0, 4)), boinkx2, drawy * 8 + boink2, 0
NEXT

FOR drawx = 1 TO xdraw - 1
FOR drawy = 1 TO ydraw - 1
put13h VARSEG(BlueWindow.windowtile(0, 8)), VARPTR(BlueWindow.windowtile(0, 8)), boink + drawx * 8, drawy * 8 + boink2, 0
NEXT drawy, drawx


END SUB

SUB DrawWindow

boink = 0

IF BlueWindow.openclosingsign = 1 THEN
IF BlueWindow.currx > BlueWindow.x1 THEN BlueWindow.currx = BlueWindow.currx - 8 ELSE boink = boink + 1
IF BlueWindow.currx2 < BlueWindow.x2 THEN BlueWindow.currx2 = BlueWindow.currx2 + 8 ELSE boink = boink + 1

IF boink = 2 THEN
IF BlueWindow.curry > BlueWindow.y1 THEN BlueWindow.curry = BlueWindow.curry - 8 ELSE boink = boink + 1
IF BlueWindow.curry2 < BlueWindow.y2 THEN BlueWindow.curry2 = BlueWindow.curry2 + 8 ELSE boink = boink + 1
END IF
IF boink = 4 THEN BlueWindow.WindowUp = 1
ELSE
IF BlueWindow.currx < BlueWindow.x1 THEN BlueWindow.currx = BlueWindow.currx + 8 ELSE boink = boink + 1
IF BlueWindow.currx2 > BlueWindow.x2 THEN BlueWindow.currx2 = BlueWindow.currx2 - 8 ELSE boink = boink + 1
IF boink = 2 THEN
IF BlueWindow.curry < BlueWindow.y1 THEN BlueWindow.curry = BlueWindow.curry + 8 ELSE boink = boink + 1
IF BlueWindow.curry2 > BlueWindow.y2 THEN BlueWindow.curry2 = BlueWindow.curry2 - 8 ELSE boink = boink + 1
END IF
IF boink = 4 THEN BlueWindow.WindowUp = -1: BlueWindow.WindowDone = 0
END IF



boink = (BlueWindow.currx \ 8) * 8
boink2 = (BlueWindow.curry \ 8) * 8
boinkx2 = (BlueWindow.currx2 \ 8) * 8
boinky2 = (BlueWindow.curry2 \ 8) * 8

xdraw = (boinkx2 \ 8) - (boink \ 8)
ydraw = (boinky2 \ 8) - (boink2 \ 8)
put13h VARSEG(BlueWindow.windowtile(0, 0)), VARPTR(BlueWindow.windowtile(0, 0)), boink, boink2, 0
put13h VARSEG(BlueWindow.windowtile(0, 2)), VARPTR(BlueWindow.windowtile(0, 2)), boink, boinky2, 0
put13h VARSEG(BlueWindow.windowtile(0, 1)), VARPTR(BlueWindow.windowtile(0, 1)), boinkx2, boink2, 0
put13h VARSEG(BlueWindow.windowtile(0, 3)), VARPTR(BlueWindow.windowtile(0, 3)), boinkx2, boinky2, 0
FOR drawx = 1 TO xdraw - 1
put13h VARSEG(BlueWindow.windowtile(0, 7)), VARPTR(BlueWindow.windowtile(0, 7)), drawx * 8 + boink, boink2, 0
put13h VARSEG(BlueWindow.windowtile(0, 6)), VARPTR(BlueWindow.windowtile(0, 6)), drawx * 8 + boink, boinky2, 0
NEXT
FOR drawy = 1 TO ydraw - 1
put13h VARSEG(BlueWindow.windowtile(0, 5)), VARPTR(BlueWindow.windowtile(0, 5)), boink, drawy * 8 + boink2, 0
put13h VARSEG(BlueWindow.windowtile(0, 4)), VARPTR(BlueWindow.windowtile(0, 4)), boinkx2, drawy * 8 + boink2, 0
NEXT

FOR drawx = 1 TO xdraw - 1
FOR drawy = 1 TO ydraw - 1
put13h VARSEG(BlueWindow.windowtile(0, 8)), VARPTR(BlueWindow.windowtile(0, 8)), boink + drawx * 8, drawy * 8 + boink2, 0
NEXT drawy, drawx

IF BlueWindow.WindowUp = 1 THEN

boing = BlueWindow.Bottom - BlueWindow.Top
FOR RenderWindowY = 0 TO boing
FOR RenderWindowX = 0 TO 37
 char = BlueWindow.buffer(RenderWindowY + BlueWindow.Top, RenderWindowX)
 IF char <> 92 THEN put13h VARSEG(BlueWindow.font(0, char)), VARPTR(BlueWindow.font(0, char)), (RenderWindowX + 1) * 8, (RenderWindowY + 1) * 8, 0
NEXT
NEXT
IF BlueWindow.WindowDone = 1 THEN fontprint 208, 59, "(PRESS SPACE)"
IF BlueWindow.WindowDone = 0 AND frames& > BlueWindow.DelayFrames THEN

b = ASC(MID$(BlueWindow.windowstr(BlueWindow.chary), BlueWindow.charx + 1, 1))

BlueWindow.buffer(BlueWindow.chary, BlueWindow.charx) = b
BlueWindow.charx = BlueWindow.charx + 1
IF b = 92 THEN BlueWindow.charx = 38
BlueWindow.DelayFrames = frames& + 1
IF b = 46 THEN BlueWindow.DelayFrames = BlueWindow.DelayFrames + 8
IF INP(&H60) < 128 THEN BlueWindow.DelayFrames = frames&
IF BlueWindow.charx > 37 THEN
 BlueWindow.charx = 0
 BlueWindow.chary = BlueWindow.chary + 1
 IF BlueWindow.chary > BlueWindow.messages THEN BlueWindow.WindowDone = 1
 IF BlueWindow.chary > BlueWindow.Bottom THEN
  BlueWindow.Bottom = BlueWindow.Bottom + 1
  IF BlueWindow.Bottom - BlueWindow.Top > BlueWindow.Linedisp THEN BlueWindow.Top = BlueWindow.Top + 1
  BlueWindow.Top = BlueWindow.Top
  IF BlueWindow.Bottom > 20 THEN BlueWindow.Bottom = 20
  IF BlueWindow.Bottom > BlueWindow.messages THEN BlueWindow.Bottom = BlueWindow.messages
 END IF

END IF
END IF




END IF
END SUB

SUB DumpStuff (describe$, id)
IF id = 0 THEN EXIT SUB
SetKey id
DIM boing(maxobjects)
found = 0
FOR i = 0 TO maxobjects
IF objects(i).idnum > 0 THEN boing(found) = i: found = found + 1
NEXT
DIM cacheobj(found) AS object
FOR i = 0 TO found
cacheobj(i) = objects(boing(i))
NEXT
OPEN "auto\" + mapdescribe$ + ".sav" FOR BINARY AS #1
PUT #1, , found
FOR i = 0 TO found
PUT #1, , cacheobj(i)
NEXT
PUT #1, , currmessage
FOR i = 0 TO currmessage
FOR j = 0 TO 20
PUT #1, , message(i).lines(j)
NEXT j, i

CLOSE #1


END SUB

SUB execbattle
copy13h
BattleOver = 0

DO
DrawPow 0, 120, 319, 199
copy13h
LOOP UNTIL BattleOver OR keyboard(57) = 1

END SUB

SUB ExecObjects

FOR doobj = 0 TO maxobjects
DoAi doobj
IF objects(doobj).idnum > -1 THEN
objects(doobj).x = objects(doobj).x + SGN(objects(doobj).queuex)
objects(doobj).queuex = objects(doobj).queuex - SGN(objects(doobj).queuex)
IF SGN(objects(doobj).queuex) <> 0 THEN objects(doobj).steps = objects(doobj).steps + 1
objects(doobj).y = objects(doobj).y + SGN(objects(doobj).queuey)
objects(doobj).queuey = objects(doobj).queuey - SGN(objects(doobj).queuey)
IF SGN(objects(doobj).queuey) <> 0 THEN objects(doobj).steps = objects(doobj).steps + 1
IF objects(doobj).storemessage <> -1 THEN SendMessage doobj, 0, objects(doobj).storemessage: objects(doobj).storemessage = -1
END IF


NEXT


END SUB

SUB ExecScript (objnum)
IF objects(objnum).delay > frames& THEN EXIT SUB
boinkline = objects(objnum).currline
SELECT CASE objects(objnum).script(boinkline, 0)
CASE sprchange
objects(objnum).spr = objects(objnum).script(boinkline, 1)
CASE lzap
boing = objects(objnum).script(boinkline, 1)
objects(objnum).zaparray(boing) = objects(objnum).zaparray(boing) + 1
CASE delay
IF objects(objnum).script(boinkline, 1) = -1 THEN
c = objects(objnum).script(boinkline, 2)
d = objects(objnum).script(boinkline, 3)
objects(objnum).delay = frames& + INT((d - c) * RND) + c
ELSE
objects(objnum).delay = frames& + objects(objnum).script(boinkline, 1)
END IF

CASE move
movex = objects(objnum).script(boinkline, 1)
movey = objects(objnum).script(boinkline, 2)
IF movex = 99 THEN movex = INT(3 * RND) - 1
IF movey = 99 THEN movey = INT(3 * RND) - 1
IF movex <> 0 AND movey <> 0 THEN movey = 0
objects(objnum).facex = movex
objects(objnum).facex = movey
a% = MoveObj%(objnum, movex, movey)
IF a% = 0 THEN objects(objnum).currline = objects(objnum).currline - 1
CASE halt
objects(objnum).currline = 0
EXIT SUB
CASE zap
objects(objnum).script(0, 0) = halt
objects(objnum).currline = 0
EXIT SUB
CASE msg
FOR i = 0 TO 20
BlueWindow.windowstr(i) = "\"
NEXT
msgnum = objects(objnum).script(boinkline, 1)
messagenum = objects(objnum).script(boinkline, 2)
FOR getmsg = 1 TO msgnum
BlueWindow.windowstr(getmsg - 1) = message(messagenum).lines(getmsg - 1)
NEXT
AddWindow 0, 0, 319, 64, msgnum
END SELECT
objects(objnum).currline = objects(objnum).currline + 1
END SUB

SUB FocusCamera
camera.x = objects(0).x - 152
camera.y = objects(0).y - 92

IF camera.x < 0 THEN camera.x = 0
IF camera.y < 0 THEN camera.y = 0
IF camera.x > 1120 THEN camera.x = 1120
IF camera.y > 1240 THEN camera.y = 1240
END SUB

SUB fontprint (x, y, text$)
startx = x
FOR i = 1 TO LEN(text$)
put13h VARSEG(BlueWindow.font(0, ASC(MID$(text$, i, 1)))), VARPTR(BlueWindow.font(0, ASC(MID$(text$, i, 1)))), startx, y, 0
startx = startx + 8
NEXT

END SUB

SUB init

FOR i = 0 TO maxobjects
objects(i).idnum = -1
NEXT

FOR i = 0 TO 89
FOR j = 0 TO 89
omap(j, i) = -1
NEXT j, i

facetable(-1, 0) = 8
facetable(1, 0) = 12
facetable(0, -1) = 4
facetable(0, 1) = 0




DEF SEG = VARSEG(BlueWindow.windowtile(0, 0))
BLOAD "put\window.put", VARPTR(BlueWindow.windowtile(0, 0))

DEF SEG = VARSEG(BlueWindow.font(0, 0))
BLOAD "put\font.put", VARPTR(BlueWindow.font(0, 0))

DEF SEG = VARSEG(coin(0))
BLOAD "put\coin.put", VARPTR(coin(0))



IF debug <> 2 THEN initkbd VARSEG(keyboard(0)), VARPTR(keyboard(0))




END SUB

SUB LoadStuff (describe$, x, y, idnum)
mapdisplayframes& = frames& + 200
DumpStuff mapdescribe$, mapid
FOR j = 0 TO 6
DisplayMap
Pixelate 2 ^ (j)
IF keyboard(41) = 0 THEN WAIT &H3DA, 8
copy13h
NEXT

IF CheckKey%(idnum) = 1 THEN SwapTo describe$, x, y, idnum: EXIT SUB

SetKey idnum
mapid = idnum
REDIM objects(maxobjects) AS object
BlueWindow.WindowOn = 0
init
AddObject x, y, 0, 0, ""
currmessage = 0
mapdescribe$ = describe$
SetScreen "scenario\" + describe$ + "\game.pal", VARSEG(dbuffer(0))
b$ = "scenario\" + describe$ + "\drunk.put"
DEF SEG = VARSEG(char(0, 0, 0))
BLOAD b$, VARPTR(char(0, 0, 0))

b$ = "scenario\" + describe$ + "\nmobj.put"
DEF SEG = VARSEG(nmobj(0, 0))
BLOAD b$, VARPTR(nmobj(0, 0))

b$ = "scenario\" + describe$ + "\battle.put"
DEF SEG = VARSEG(Battle(0, 0, 0))
BLOAD b$, VARPTR(Battle(0, 0, 0))

b$ = "scenario\" + describe$ + "\" + describe$ + ".put"
DEF SEG = VARSEG(tiles(0, 0))
BLOAD b$, VARPTR(tiles(0, 0))

b$ = "scenario\" + describe$ + "\" + describe$ + ".dat"
DEF SEG = VARSEG(map(0, 0))
BLOAD b$, VARPTR(map(0, 0))

b$ = "scenario\" + describe$ + "\map.lst"
OPEN b$ FOR INPUT AS #1

INPUT #1, num
DIM blah$(1 TO num)
DIM oname$(1 TO num)
FOR i = 1 TO num
INPUT #1, oname$(i), blah$(i), x, y, id, spr
AddObject x, y, id, spr, blah$(i)
NEXT
CLOSE #1

FOR i = 1 TO num
b$ = "scenario\" + mapdescribe$ + "\" + RTRIM$(objects(i).sfile) + ".scr"
OPEN b$ FOR INPUT AS #1
ProcessLine 1, 0, "MAIN:"
currline = 0
DO
INPUT #1, a$
SELECT CASE a$
CASE "DELAY"
objects(i).script(currline, 0) = delay
INPUT #1, a
objects(i).script(currline, 1) = a
IF a = -1 THEN
INPUT #1, a, b
objects(i).script(currline, 2) = a
objects(i).script(currline, 3) = b
END IF
CASE "LZAP"
objects(i).script(currline, 0) = lzap
INPUT #1, a
objects(i).script(currline, 1) = a

CASE "SPR"
objects(i).script(currline, 0) = sprchange
INPUT #1, a
objects(i).script(currline, 1) = a

CASE "MOVE"
objects(i).script(currline, 0) = move
INPUT #1, a, b
objects(i).script(currline, 1) = a
objects(i).script(currline, 2) = b
CASE "ZAP"
objects(i).script(currline, 0) = zap
CASE "END"
objects(i).script(currline, 0) = halt: EXIT DO
CASE "MSG"
objects(i).script(currline, 0) = msg
INPUT #1, num
objects(i).script(currline, 1) = num
FOR a = 1 TO num
INPUT #1, a$
message(currmessage).lines(a - 1) = a$
NEXT
objects(i).script(currline, 2) = currmessage
currmessage = currmessage + 1
END SELECT
currline = currline + 1
LOOP

CLOSE #1
NEXT

FocusCamera
FOR j = 6 TO 0 STEP -1
DisplayMap
Pixelate 2 ^ (j)
IF keyboard(41) = 0 THEN WAIT &H3DA, 8
copy13h
NEXT




END SUB

FUNCTION MoveObj% (objnum, facex, facey)

IF objects(objnum).queuex = 0 AND objects(objnum).queuey = 0 THEN
IF facex = 0 AND facey = 0 THEN EXIT FUNCTION
boink = objects(objnum).x + (16 * facex)
boinky = objects(objnum).y + (16 * facey)
boinkx2 = objects(objnum).x + 15 + (16 * facex)
boinky2 = objects(objnum).y + 15 + (16 * facey)
test = map(boink \ 16, boinky \ 16)
test2 = omap(boink \ 16, boinky \ 16)
IF test2 <> -1 THEN SendMessage test2, objnum, hit
IF test < 255 AND test2 = -1 THEN
MoveObj% = 1
objects(objnum).queuex = 16 * facex
objects(objnum).queuey = 16 * facey
omap(objects(objnum).x \ 16, objects(objnum).y \ 16) = -1
omap(boink \ 16, boinky \ 16) = objnum
ELSE
objects(objnum).frames = facetable(facex, facey)
END IF
END IF
END FUNCTION

SUB Pixelate (divisor)

a! = TIMER
DO: LOOP UNTIL a! <> TIMER
a! = TIMER
DO: LOOP UNTIL a! <> TIMER

DIM freq(15) AS INTEGER
DEF SEG = VARSEG(dbuffer(0))
bonk = 320 \ divisor
boing = 200 \ divisor
startx = 0
starty = 0

FOR i = 0 TO boing - 1
FOR j = 0 TO bonk - 1

col = PEEK(starty * 320& + startx)
FOR writey = 0 TO divisor - 1
FOR writex = 0 TO divisor - 1
doink = starty + writey
IF doink > 199 THEN doink = 199
doink2 = startx + writex
IF doink2 > 319 THEN doink2 = 319
POKE ((320& * doink) + doink2), col
NEXT writex, writey

startx = startx + divisor
NEXT j
startx = 0
starty = starty + divisor
NEXT i
END SUB

SUB ProcessCommands (obj, fromobj, filenum, message)

DO

INPUT #filenum, a$
SELECT CASE a$
CASE "LZAP"
INPUT #filenum, num
objects(obj).zaparray(num) = objects(obj).zaparray(num) + 1
CASE "TESTFLAG"
INPUT #filenum, flag, mess$
IF flags(flag) = 1 THEN
SELECT CASE mess$
CASE "HIT"
objects(obj).storemessage = 1
CASE "COINMSG"
objects(obj).storemessage = 2
END SELECT
END IF

CASE "FLAG"
INPUT #filenum, flag
flags(flag) = 1
CASE "COIN"
IF CoinCounter = 1 THEN coins = coins + 1 ELSE CoinCounter = 1
CASE "LOAD"
INPUT #filenum, bif$, x, y, id
CLOSE #filenum
LoadStuff bif$, x, y, id
EXIT SUB
CASE "ZAP"
objects(obj).zaparray(message) = objects(obj).zaparray(message) + 1
CASE "END"
        EXIT DO
CASE "MSG"
        INPUT #filenum, msgnum
        FOR i = 0 TO 20
        BlueWindow.windowstr(i) = "\"
        NEXT
        FOR getmsg = 1 TO msgnum
        INPUT #filenum, BlueWindow.windowstr(getmsg - 1)
        NEXT
        
        AddWindow 0, 0, 319, 64, msgnum
        
END SELECT
LOOP

END SUB

SUB ProcessLine (filenum, commandnum, search$)
found = -1
DO
INPUT #filenum, blah$
IF blah$ = search$ THEN found = found + 1
LOOP UNTIL found = commandnum

END SUB

SUB RenderMap
END SUB

SUB SendMessage (objnum, fromobj, message)
IF objnum = fromobj THEN EXIT SUB
IF fromobj = 0 THEN
SELECT CASE objects(objnum).idnum
CASE 0
CASE 1, 2, 3
b$ = "scenario\" + mapdescribe$ + "\" + RTRIM$(objects(objnum).sfile) + ".scr"
OPEN b$ FOR INPUT AS #1
SELECT CASE message
CASE hit
ProcessLine 1, objects(objnum).zaparray(message), "HIT:"
CASE 2
ProcessLine 1, objects(objnum).zaparray(message), "COINMSG:"
END SELECT
ProcessCommands objnum, fromobj, 1, message
CLOSE #1
END SELECT
END IF
END SUB

SUB SetKey (num)
DIM tkey(4)
OPEN "auto\maptog.dat" FOR INPUT AS #1
INPUT #1, tkey(0)
INPUT #1, tkey(1)
INPUT #1, tkey(2)
INPUT #1, tkey(3)
INPUT #1, tkey(4)
CLOSE #1

tkey(num - 1) = 1
OPEN "auto\maptog.dat" FOR OUTPUT AS #1
PRINT #1, tkey(0)
PRINT #1, tkey(1)
PRINT #1, tkey(2)
PRINT #1, tkey(3)
PRINT #1, tkey(4)
CLOSE #1

END SUB

SUB SetScreen (palfile$, bufseg)
SCREEN 13
setsegments13h bufseg, &HA000
a = FREEFILE
OPEN palfile$ FOR BINARY AS #1
FOR i = 0 TO 767
OUT &H3C9, ASC(INPUT$(1, 1))
NEXT
CLOSE #1

END SUB

SUB SwapTo (describe$, x, y, id)

mapid = id
BlueWindow.WindowOn = 0

FOR i = 0 TO 89
FOR j = 0 TO 89
omap(i, j) = -1
NEXT j, i
FOR i = 0 TO maxobjects
objects(i).idnum = -1
NEXT

AddObject x, y, 0, 0, ""

mapdescribe$ = describe$

SetScreen "scenario\" + describe$ + "\game.pal", VARSEG(dbuffer(0))
b$ = "scenario\" + describe$ + "\drunk.put"
DEF SEG = VARSEG(char(0, 0, 0))
BLOAD b$, VARPTR(char(0, 0, 0))

b$ = "scenario\" + describe$ + "\nmobj.put"
DEF SEG = VARSEG(nmobj(0, 0))
BLOAD b$, VARPTR(nmobj(0, 0))

b$ = "scenario\" + describe$ + "\battle.put"
DEF SEG = VARSEG(Battle(0, 0, 0))
BLOAD b$, VARPTR(Battle(0, 0, 0))

b$ = "scenario\" + describe$ + "\" + describe$ + ".put"
DEF SEG = VARSEG(tiles(0, 0))
BLOAD b$, VARPTR(tiles(0, 0))

b$ = "scenario\" + describe$ + "\" + describe$ + ".dat"
DEF SEG = VARSEG(map(0, 0))
BLOAD b$, VARPTR(map(0, 0))


OPEN "auto\" + mapdescribe$ + ".sav" FOR BINARY AS #1
GET #1, , found
DIM cacheobj(found) AS object
FOR i = 0 TO found
GET #1, , cacheobj(i)
NEXT
GET #1, , currmessage
FOR i = 0 TO currmessage
FOR j = 0 TO 20
GET #1, , message(i).lines(j)
NEXT j, i
CLOSE #1
FOR i = 0 TO found
objects(i + 1) = cacheobj(i)
IF objects(i + 1).idnum = 0 THEN objects(i + 1).idnum = -1
NEXT

FOR i = 0 TO maxobjects
IF objects(i).idnum <> -1 THEN
objects(i).x = (objects(i).x \ 16) * 16
objects(i).queuex = 0
objects(i).y = (objects(i).y \ 16) * 16
objects(i).queuey = 0
omap(objects(i).x \ 16, objects(i).y \ 16) = i
END IF
NEXT
FocusCamera
FOR j = 6 TO 0 STEP -1
DisplayMap
Pixelate 2 ^ (j)
IF keyboard(41) = 0 THEN WAIT &H3DA, 8
copy13h
NEXT

END SUB

SUB WipeKey

OPEN "auto\maptog.dat" FOR OUTPUT AS #1
PRINT #1, 0
PRINT #1, 0
PRINT #1, 0
PRINT #1, 0
PRINT #1, 0
CLOSE #1

END SUB

